#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
#-----------------------------------------------------------------------------
Name		:	sddm
Version		:	0.20.0
Release		:	14.8.0.0%{?dist}
Summary		:	QML based X11 desktop manager
Group		:	System Environment/Libraries

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	MIT
URL		:	https://github.com/sddm/sddm/releases

Source0		:	%{name}-%{version}.tar.gz
Source1		:	%{name}-ok_addon.tar.gz
#-----------------------------------------------------------------------------
BuildRequires	:	elogind-devel	
BuildRequires	:	extra-cmake-modules
BuildRequires	:	glade
BuildRequires	:	libxcb
BuildRequires	:	pam-devel	
BuildRequires	:	python3-docutils
BuildRequires	:	qt

Requires	:	/usr/sbin/useradd, /usr/sbin/userdel
Requires	:	/usr/sbin/groupadd, /usr/sbin/groupdel
Requires	:	chkconfig
Requires	:	elogind
Requires	:	lfs-bootscripts
Requires	:	pam
Requires	:	setxkbmap
Requires	:	xrdb

#-----------------------------------------------------------------------------
%description
SDDM is a modern display manager for X11 and Wayland aiming to be
fast, simple and beautiful.
It uses modern technologies like QtQuick, which in turn gives the
designer the ability to create smooth, animated user interfaces.

SDDM is extremely themeable. We put no restrictions on the user
interface design, it is completely up to the designer. We simply
provide a few callbacks to the user interface which can be used
for authentication, suspend etc.

#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)
%doc README.md LICENSE
%config(noreplace) %{_sysconfdir}/pam.d/*
%config(noreplace) %{_sysconfdir}/%{name}.conf
%{_sysconfdir}/dbus-1/system.d/*
%dir %attr(0755,%{name},%{name}) %{_var}/lib/%{name}
%dir %attr(0755,%{name},%{name}) %{_prefix}/lib/%{name}/%{name}.d
%dir %attr(0755,%{name},%{name}) %{_sysconfdir}/%{name}.d
%{_libexecdir}/%{name}-helper
%{_bindir}/%{name}
%{_bindir}/%{name}-*
%{_datadir}/qml/*
%{_datadir}/%{name}/*
%{_libexecdir}/%{name}-helper-start-*
%{_mandir}/man1/%{name}-greeter.1.gz
%{_mandir}/man1/%{name}.1.gz
%{_mandir}/man5/%{name}-state.conf.5.gz
%{_mandir}/man5/%{name}.conf.5.gz


#-----------------------------------------------------------------------------
%pre 
if [ "$1" = 1 ]; then
  /usr/sbin/groupadd				\
	-K GID_MIN=50				\
	-K GID_MAX=99				\
	 %{name}

  /usr/sbin/useradd 				\
	-r					\
	-c "SDDM daemon"			\
	-K SYS_UID_MIN=50			\
	-K SYS_UID_MAX=99			\
	-g %{name}				\
	-s /bin/false				\
	-d %{_var}/lib/%{name}			\
	%{name}
  fi

#-----------------------------------------------------------------------------
#after upgrade or remove
%preun
if [ "$1" = 0 ]; then
  /usr/sbin/userdel %{name}
  (
  /bin/echo -n "%{name}-%{version} has been fully removed on "; date
  ) > %{_var}/log/README-%{name}-removed
  fi
#-----------------------------------------------------------------------------
%post
/usr/sbin/ldconfig

#-----------------------------------------------------------------------------
%postun
/usr/sbin/ldconfig

#=============================================================================
%prep
%setup -q
%{__tar} xf %{SOURCE1}

#adjusting sddm pam file (for howdy)
cp -a							\
	%{name}-ok_addon/*.pam services

#-----------------------------------------------------------------------------
#building application
%build

%define	conffile	sddm_org.freedesktop.DisplayManager.conf
sed -i								\
  -e '/UPOWER_SERVICE)/ s:^://:'				\
  src/daemon/PowerManager.cpp

#NOT needed if elogind is replacing ConsoleKit2
#sed -i								\
#  -e '/\$@$/s/exec/& ck-launch-session/'			\
#  data/scripts/Xsession

#adding keyboard 4 layout within Xsetup and xrandr definition
cat %{name}-ok_addon/Xsetup_addon >> data/scripts/Xsetup

%{__mkdir_p} build
pushd build

cmake								\
	-DCMAKE_INSTALL_PREFIX=%{_prefix}			\
	-DCMAKE_INSTALL_LIBDIR=%{_libdir}			\
	-DCMAKE_BUILD_TYPE=Debug				\
	-DCMAKE_BUILD_TYPE:STRING="Release" 			\
	-DBUILD_MAN_PAGES=ON					\
	-DENABLE_PAM=ON						\
	-DNO_SYSTEMD=ON						\
	-DENABLE_JOURNALD=OFF					\
	-DUSE_ELOGIND=ON					\
	-DUID_MIN=300						\
      	-DDBUS_CONFIG_FILENAME=%{conffile}			\
	-DSESSION_COMMAND:PATH=/etc/X11/xinit/Xsession		\
	-DWAYLAND_SESSION_COMMAND:PATH=/etc/sddm/wayland-session\
	-Wno-dev						\
	..

%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
%{__make} %{_smp_mflags}


popd

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

%{__make}							\
	-C build						\
	DESTDIR=%{buildroot}					\
	install

%{__mkdir_p} %{buildroot}%{_var}/lib/%{name}
%{__mkdir_p} %{buildroot}%{_prefix}/lib/%{name}/%{name}.d
%{__mkdir_p} %{buildroot}%{_sysconfdir}/%{name}.d

#duplicating sddm.conf
cp -a								\
	%{name}-ok_addon/%{name}.conf				\
	%{buildroot}%{_sysconfdir}
	
#selecting the sddm theme
sed -i								\
  -e "s/^Current=/Current=maldives/"				\
  -e "s/^InputMethod=/#InputMethod=/"				\
  -e "/^#InputMethod=/ aInputMethod="				\
  %{buildroot}%{_sysconfdir}/%{name}.conf

#-----------------------------------------------------------------------------
%changelog
